Bug 485167 - genisoimage doesn't preserve hardlinks
genisoimage doesn't preserve hardlinks
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: cdrkit (Show other bugs)
11
All Linux
low Severity medium
: ---
: ---
Assigned To: Nikola Pajkovsky
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-02-11 19:57 EST by Jesse Keating
Modified: 2014-02-02 17:13 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-06-28 07:15:36 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jesse Keating 2009-02-11 19:57:54 EST
With a CLI call of:

/usr/bin/mkisofs -v -U -J -R -T -m repoview -m images/boot.iso -b isolinux/isolinux.bin -c isolinux/boot.cat -no-emul-boot -boot-load-size 4 -boot-info-table -V "Fedora 20090211 x86_64 DVD" -o /srv/pungi/raw11.1/20090211/x86_64/iso/Fedora-20090211-x86_64-DVD.iso /srv/pungi/raw11.1/20090211/x86_64/os

genisoimage is not preserving the hardlinks that are in the path.  Once written out and mounted, the files that share the same inode in the path do not have a common inode on the iso file.

This is causing Fedora CDs to be too large due to size estimations taking hardlink into account and genisoimage not.
Comment 1 Jörg Schilling 2009-02-12 09:21:28 EST
genisoimage is based on a completely outdated version of mkisofs
and genisoimage is unmaintained.

Mkisofs is well maintained and introduced support for correct hardlinks
in Summer 2006.

I recommand you to upgrade to recent original software from:

ftp://ftp.berlios.de/pub/cdrecord/alpha/

If you still do not see correct hard links, you would need to upgrade 
the linux kernel too. I did this with the Solaris ISO-9660/RR driver in
Summer 2006.
Comment 2 Jesse Keating 2009-02-13 14:32:07 EST
Turns out I was looking at it wrong.  The inodes are different, but apparently they point to the same blocks on the disk, thus the space is saved.  I'd suggest the man page gets changed to reflect this.
Comment 3 Jörg Schilling 2009-02-13 14:52:19 EST
If you use the official mkisofs instead of genisoimage, the
inode numbers are identical for all hard linked file names.
This is needed if you ever like to copy the files correctly
from the CD/DVD.
Comment 4 Jesse Keating 2009-02-13 17:00:40 EST
Until such time that GPL licensed mkisofs doesn't require the CDDL licensed libscg, Fedora cannot make use of that software.
Comment 5 Jörg Schilling 2009-02-13 19:25:17 EST
Do you know what you are talking about?

RedHat currently publishes a mkisofs fork that is
in conflict with GPL and Copyright and thus cannot
be legally distributed.

Do you believe that there would be a problem if Redhat 
did publish the legal original instead?
Comment 6 Jesse Keating 2009-02-13 19:41:04 EST
I do believe that you are misinformed.
Comment 7 Jörg Schilling 2009-02-14 05:40:13 EST
I am the Copyrightholder and I know that you are missinformed.
Comment 8 Bug Zapper 2009-06-09 07:17:39 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 11 development cycle.
Changing version to '11'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 9 Bug Zapper 2010-04-27 08:56:35 EDT
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 10 Jörg Schilling 2010-04-27 10:36:14 EDT
Note that this bug is obviously independent from the the
Fedora release. The only way to fix the problem is to 
upgrade to recent _original_ software from 

http://cdrecord.berlios.de

Correct hard link support is in mkisofs since Autumn 2006,
so it it obvious that Redhat is ignoring new versions 
since a looooong time....
Comment 11 Bug Zapper 2010-06-28 07:15:36 EDT
Fedora 11 changed to end-of-life (EOL) status on 2010-06-25. Fedora 11 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 12 Jörg Schilling 2010-06-29 10:42:36 EDT
As this bug is caused by the fact that RedHat does not ship
recent original software but rather a uses dead fork from a
really old version of cdrtools, RedHat users do not partcipate
on the development of the OSS project.

It is obvious that as long as Redhat does not upgrade to
recent original software, this bug will continue to exist.

Note You need to log in before you can comment on or make changes to this bug.